from direct.showbase.ShowBase import ShowBase
from panda3d.core import *
from direct.gui.DirectGui import *
import random

configVars = """
win-size 1024 768
load-display pandagl
show-frame-rate-meter true
textures-power-2 false
undecorated true
window-title tower
fullscreen false
"""

loadPrcFileData("", configVars)


class MyGame(ShowBase):
    def __init__(self):
        super().__init__()
        self.set_background_color(0.1, 0.1, 0.1, 1)
        self.cam.setPos(0, -20, 0)
        base.disableMouse()

        font = loader.loadFont('assets/fonts/arial.ttf')
        gothic = loader.loadFont('assets/fonts/HondaC.ttf')

        #ополченец = [координата иконки х, координата иконки у, максимальное здоровье,текущее здоровье, атака, физическая броня, магическая броня, инициатива, кол-во ударов.]
        self.militiaman = [0.0625, 0, 100, 100, 40, 0, 0, 20, 1]
        self.knight = [0.125, 0, 200, 200, 60, 20, 0, 20, 1]
        self.archer = [0.1875, 0, 100, 100, 40, 0, 0, 30, 1]


        lens = OrthographicLens()
        lens.setFilmSize(32, 24)
        self.cam.node().setLens(lens)

        self.button_1 = self.createButton(gothic, "Нанять", 0.08, -0.12, -0.02, 376, -176, self.hiring_militiaman)
        self.button_2 = self.createButton(gothic, "Нанять", 0.08, -0.12, -0.02, 520, -176, self.hiring_archer)        
        self.town_1 = [0, 0, 0, 0, 0, self.knight, 0, 0]

        self.gold = 1000
        self.number_click = 0
        self.a = 0
        self.b = 0
        self.z = 0

        self.copy_slot_1 = 0

        self.slot_1 = self.collisionSlot(-13.625, 3.5, 0)
        self.slot_2 = self.collisionSlot(-13.625, -0.875, 1)
        self.slot_3 = self.collisionSlot(-13.625, -5.25, 2)
        self.slot_4 = self.collisionSlot(-13.625, -9.625, 3)
        self.slot_5 = self.collisionSlot(-9.25, 3.5, 4)
        self.slot_6 = self.collisionSlot(-9.25, -0.875, 5)
        self.slot_7 = self.collisionSlot(-9.25, -5.25, 6)
        self.slot_8 = self.collisionSlot(-9.25, -9.625, 7)

        
        self.interface = self.loader.loadModel("assets/eggs/interface_11")
        self.interface_texture = self.loader.loadTexture("assets/images/interface_11.png")
        self.interface.setPos(0, 0, 0)
        self.interface.setScale(0.666666, 0, 0.888888)
        self.interface_texture.setMagfilter(SamplerState.FT_nearest)
        self.interface.setTransparency(TransparencyAttrib.MAlpha)
        self.interface.setTexture(self.interface_texture)
        self.interface.reparentTo(self.aspect2d)


        self.militiaman_icon = self.createSprite("assets/images/unit_icons.png", 376, 0, -80)
        self.archer_icon = self.createSprite("assets/images/unit_icons.png", 520, 0, -80)
        
        self.militiaman_icon.setTexOffset(TextureStage.getDefault(), (0.0625, 0))       
        self.archer_icon.setTexOffset(TextureStage.getDefault(), (0.1875, 0))


        self.picker = CollisionTraverser()
        self.pq = CollisionHandlerQueue()

        self.pickerNode = CollisionNode('mouseRay')
        self.pickerNP = camera.attachNewNode(self.pickerNode)

        self.pickerRay = CollisionRay()
        self.pickerNode.addSolid(self.pickerRay)
        self.picker.addCollider(self.pickerNP,self.pq)
        

        self.accept("mouse1",self.mouseClick)



        
# спрайты которые будут отображать воинов
        self.sprite_1 = self.createSprite("assets/images/unit_icons.png", 76, 0, -272)
        self.sprite_2 = self.createSprite("assets/images/unit_icons.png", 76, 0, -412)
        self.sprite_3 = self.createSprite("assets/images/unit_icons.png", 76, 0, -552)
        self.sprite_4 = self.createSprite("assets/images/unit_icons.png", 76, 0, -692)
        self.sprite_5 = self.createSprite("assets/images/unit_icons.png", 216, 0, -272)
        self.sprite_6 = self.createSprite("assets/images/unit_icons.png", 216, 0, -412)
        self.sprite_7 = self.createSprite("assets/images/unit_icons.png", 216, 0, -552)
        self.sprite_8 = self.createSprite("assets/images/unit_icons.png", 216, 0, -692)

        self.taskMgr.add(self.update_texture, "Update texture")

    def update_texture(self, task):

        if base.mouseWatcherNode.has_mouse():
    
            mpos = base.mouseWatcherNode.get_mouse()
            mpos_x = mpos[0]*512
            mpos_y = mpos[1]*384

#изменение иконки в зависимости от того что прописано в отряде/городе, если клетка пустая тогда пустое окно если нет значит там есть солдат и его иконку нужно поставить в слоте
     
        if self.town_1[0] != 0:
            self.sprite_1.setTexOffset(TextureStage.getDefault(), (self.town_1[0])[0], (self.town_1[0])[1])
        else:
            self.sprite_1.setTexOffset(TextureStage.getDefault(), 0, 0)
        if self.town_1[1] != 0:
            self.sprite_2.setTexOffset(TextureStage.getDefault(), (self.town_1[1])[0], (self.town_1[1])[1])            
        else:
            self.sprite_2.setTexOffset(TextureStage.getDefault(), 0, 0)
        if self.town_1[2] != 0:
            self.sprite_3.setTexOffset(TextureStage.getDefault(), (self.town_1[2])[0], (self.town_1[2])[1])
        else:
            self.sprite_3.setTexOffset(TextureStage.getDefault(), 0, 0)
        if self.town_1[3] != 0:
            self.sprite_4.setTexOffset(TextureStage.getDefault(), (self.town_1[3])[0], (self.town_1[3])[1])
        else:
            self.sprite_4.setTexOffset(TextureStage.getDefault(), 0, 0)
        if self.town_1[4] != 0:
            self.sprite_5.setTexOffset(TextureStage.getDefault(), (self.town_1[4])[0], (self.town_1[4])[1])
        else:
            self.sprite_5.setTexOffset(TextureStage.getDefault(), 0, 0)
        if self.town_1[5] != 0:
            self.sprite_6.setTexOffset(TextureStage.getDefault(), (self.town_1[5])[0], (self.town_1[5])[1])
        else:
            self.sprite_6.setTexOffset(TextureStage.getDefault(), 0, 0)
        if self.town_1[6] != 0:
            self.sprite_7.setTexOffset(TextureStage.getDefault(), (self.town_1[6])[0], (self.town_1[6])[1])
        else:
            self.sprite_7.setTexOffset(TextureStage.getDefault(), 0, 0)
        if self.town_1[7] != 0:
            self.sprite_8.setTexOffset(TextureStage.getDefault(), (self.town_1[7])[0], (self.town_1[7])[1])
        else:
            self.sprite_8.setTexOffset(TextureStage.getDefault(), 0, 0)
        return task.cont

    def mouseClick(self):
        if base.mouseWatcherNode.hasMouse():
            mpos = base.mouseWatcherNode.getMouse()
            self.pickerRay.setFromLens(base.camNode,mpos.getX(),mpos.getY())
            self.picker.traverse(render)
            if self.pq.getNumEntries() > 0:
                self.number_click += 1
                self.pq.sortEntries()
                pickedObj = self.pq.getEntry(0).getIntoNodePath()
                t = pickedObj.getNetTag('test')
                if self.number_click == 1:
                    self.a = self.town_1[int(t)]
                    self.z = int(t)
                if self.number_click == 2:
                    self.b = self.town_1[int(t)]
                if self.number_click == 2:                    
                    self.town_1[int(t)] = self.a
                    self.town_1[self.z] = self.b                    
                    self.number_click = 0

#найм ополченца
    def hiring_militiaman(self):
        
        if 0 in self.town_1:
            x = self.town_1.index(0)
            self.town_1[x] = self.militiaman
       
#найм лучника
    def hiring_archer(self):
        
        if 0 in self.town_1:
            x = self.town_1.index(0)
            self.town_1[x] = self.archer



    def collisionSlot(self, pos_x, pos_y, number):
        sprite = self.loader.loadModel("assets/eggs/64_64")
        sprite.reparentTo(render)
        sprite.setScale(15, 15, 15)
        sprite.setPos(pos_x, 1, pos_y)
        sprite.setCollideMask(BitMask32.bit(1))
        sprite.setTag('test', str(number))
        return sprite

    
    def createSprite(self, name, pos_x, pos_z, pox_y):
        sprite = loader.loadModel("assets/eggs/unit_icons")
        sprite_tex = loader.loadTexture(name)
        sprite.setPos(pos_x, pos_z, pox_y)
        sprite.setScale(64, 0, 64)
        sprite.setTexture(sprite_tex)
        sprite_tex.setMagfilter(SamplerState.FT_nearest)
        sprite.reparentTo(pixel2d)
        return sprite

 
    def Button_Close(self, text_font, text, scale, txt_x, txt_y, pos_x, pos_y, command_button):

        maps = loader.loadModel("assets/button_close")
        btnGeom = (maps.find("**/close_ready"),
                    maps.find("**/close_click"),
                    maps.find("**/close_rollover"),
                    maps.find("**/close_disabled"))

        btn = DirectButton(
            text = text,
            text_font = text_font,
            text_fg = (0.6901, 0.5372, 0.3686, 1),
            text_scale = scale,
            text_pos = (txt_x, txt_y),
            text_align = TextNode.ALeft,
            scale = 240,
            pos = (pos_x, 0, pos_y),
            geom = btnGeom,
            relief = 0,
            frameColor = (0,0,0,0),
            command = command_button,
            parent = pixel2d,
            pressEffect = False,
            rolloverSound = None,
            clickSound = None)
        return btn

    
    def createButton(self, text_font, text, scale, txt_x, txt_y, pos_x, pos_y, command_button):

        maps = loader.loadModel("assets/button_maps")
        btnGeom = (maps.find("**/button_ready"),
                    maps.find("**/button_click"),
                    maps.find("**/button_rollover"),
                    maps.find("**/button_disabled"))

        btn = DirectButton(
            text = text,
            text_font = text_font,
            text_fg = (0.6901, 0.5372, 0.3686, 1),
            text_scale = scale,
            text_pos = (txt_x, txt_y),
            text_align = TextNode.ALeft,
            scale = 240,
            pos = (pos_x, 0, pos_y),
            geom = btnGeom,
            relief = 0,
            frameColor = (0,0,0,0),
            command = command_button,
            parent = pixel2d,
            pressEffect = False,
            rolloverSound = None,
            clickSound = None)
        return btn

game = MyGame()
game.run()
